#!/bin/bash


# error exit
error_exit() {
    /usr/local/bin/ledcont accblink
    /usr/local/bin/ledcont pwrblink
    /usr/local/sbin/leddrv_unload
    exit 1
}

# wait_atalk_daemon
# ATALKSERVICE=
wait_atalk_daemon(){
  [ -f /home/LANDISK/landisk-config ] && 
  ATALKSERVICE=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "ATALKSERVICE" | awk -F "=" '{print $2}')
  if [ "${ATALKSERVICE}" = "on" ]; then
    i=0
    while [ $i -lt 180 ]; do
      ps | grep "S92netatalk" >& /dev/null
      if [ $? -ne 0 ]; then
        ps | grep "atalkd" >& /dev/null
        if [ $? -ne 0 ]; then
          break;
        fi
      fi
      sleep 1
      i=$((i+1))
    done
  fi
  ps | grep "atalkd" >& /dev/null
  if [ $? -eq 0 ]; then
    kill -9 `ps | grep "atalkd" | awk '{print $1}'`
  fi
  sleep 3
}


UPDATEVERSION="1.54"

# LED control.
/usr/local/bin/ledcont cycle 8
/usr/local/bin/ledcont pwrblink


#
# check system type and version.
#

# system type
[ -f /home/LANDISK/landisk-config ] && SYSTEMTYPE=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "SYSTEMTYPE" | awk -F "=" '{print $2}')

[ "${SYSTEMTYPE}" != "ide" ] && error_exit

# system version
[ -f /home/LANDISK/landisk-config ] && SYSTEMVERSION=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "SYSTEMVERSION" | awk -F "=" '{print $2}')

# delete . from version
SYSVERINT=$(echo "${SYSTEMVERSION}" | cut -d "." -f 1)
SYSVERFLOAT=$(echo "${SYSTEMVERSION}" | cut -d "." -f 2)
SYSVER="${SYSVERINT}${SYSVERFLOAT}"

# delete . from version
UPVERINT=$(echo "${UPDATEVERSION}" | cut -d "." -f 1)
UPVERFLOAT=$(echo "${UPDATEVERSION}" | cut -d "." -f 2)
UPVER="${UPVERINT}${UPVERFLOAT}"

[ ${SYSVER} -gt ${UPVER} ] && error_exit
if [ ${SYSVER} = "110" ]; then
	VER110UP="true"
fi
if [ ${SYSVER} = "120" ]; then
	VER120UP="true"
	VER110UP="true"
	# system version
	[ -f /home/LANDISK/landisk-config ] && AVELLINK=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "AVELLINK" | awk -F "=" '{print $2}')
fi
if [ ${SYSVER} = "121" ]; then
	VER121UP="true"
	VER120UP="true"
	VER110UP="true"
	# system version
	[ -f /home/LANDISK/landisk-config ] && AVELLINK=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "AVELLINK" | awk -F "=" '{print $2}')
fi
if [ ${SYSVER} = "130" ]; then
	VER130UP="true"
	VER121UP="true"
	VER120UP="true"
	VER110UP="true"
	# system version
	[ -f /home/LANDISK/landisk-config ] && AVELLINK=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "AVELLINK" | awk -F "=" '{print $2}')
	[ -f /home/LANDISK/landisk-config ] && FATSHARE=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "FATSHARE" | awk -F "=" '{print $2}')
	[ -f /home/LANDISK/landisk-config ] && FATWINERITE=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "FATWINWRITE" | awk -F "=" '{print $2}')
	[ -f /home/LANDISK/landisk-config ] && ATALKCODE=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "ATALKCODE" | awk -F "=" '{print $2}')
fi
if [ ${SYSVER} = "140" ]; then
	VER140UP="true"
	VER130UP="true"
	VER121UP="true"
	VER120UP="true"
	VER110UP="true"
	# system version
	[ -f /home/LANDISK/landisk-config ] && AVELLINK=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "AVELLINK" | awk -F "=" '{print $2}')
fi
if [ ${SYSVER} = "141" ]; then
	VER141UP="true"
	VER140UP="true"
	VER130UP="true"
	VER121UP="true"
	VER120UP="true"
	VER110UP="true"
	[ -f /home/LANDISK/landisk-config ] && AVELLINK=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "AVELLINK" | awk -F "=" '{print $2}')
fi
if [ ${SYSVER} = "142" ]; then
	VER142UP="true"
	VER141UP="true"
	VER140UP="true"
	VER130UP="true"
	VER121UP="true"
	VER120UP="true"
	VER110UP="true"
	[ -f /home/LANDISK/landisk-config ] && AVELLINK=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "AVELLINK" | awk -F "=" '{print $2}')
fi
if [ ${SYSVER} = "150" ]; then
	VER150UP="true"
	VER142UP="true"
	VER141UP="true"
	VER140UP="true"
	VER130UP="true"
	VER121UP="true"
	VER120UP="true"
	VER110UP="true"
	[ -f /home/LANDISK/landisk-config ] && AVELLINK=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "AVELLINK" | awk -F "=" '{print $2}')
fi
if [ ${SYSVER} = "151" ]; then
	VER151UP="true"
	VER150UP="true"
	VER142UP="true"
	VER141UP="true"
	VER140UP="true"
	VER130UP="true"
	VER121UP="true"
	VER120UP="true"
	VER110UP="true"
	[ -f /home/LANDISK/landisk-config ] && AVELLINK=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "AVELLINK" | awk -F "=" '{print $2}')
fi
if [ ${SYSVER} = "152" ]; then
	VER152UP="true"
	VER151UP="true"
	VER150UP="true"
	VER142UP="true"
	VER141UP="true"
	VER140UP="true"
	VER130UP="true"
	VER121UP="true"
	VER120UP="true"
	VER110UP="true"
	[ -f /home/LANDISK/landisk-config ] && AVELLINK=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "AVELLINK" | awk -F "=" '{print $2}')
fi
if [ ${SYSVER} = "153" ]; then
	VER153UP="true"
	VER152UP="true"
	VER151UP="true"
	VER150UP="true"
	VER142UP="true"
	VER141UP="true"
	VER140UP="true"
	VER130UP="true"
	VER121UP="true"
	VER120UP="true"
	VER110UP="true"
	[ -f /home/LANDISK/landisk-config ] && AVELLINK=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "AVELLINK" | awk -F "=" '{print $2}')
fi
if [ ${SYSVER} = "154" ]; then
	VER154UP="true"
	VER153UP="true"
	VER152UP="true"
	VER151UP="true"
	VER150UP="true"
	VER142UP="true"
	VER141UP="true"
	VER140UP="true"
	VER130UP="true"
	VER121UP="true"
	VER120UP="true"
	VER110UP="true"
	[ -f /home/LANDISK/landisk-config ] && AVELLINK=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "AVELLINK" | awk -F "=" '{print $2}')
fi




/usr/bin/killall atkickd >& /dev/null
/home/LANDISK/scripts/killftpd.sh stop
/etc/rc.d/init.d/S99reset_daemon stop
/etc/rc.d/init.d/S92netatalk stop
/etc/rc.d/init.d/S91samba stop
# /etc/rc.d/init.d/S95httpd stop
/etc/rc.d/init.d/S90identd stop
/etc/rc.d/init.d/S60lpd stop
/etc/rc.d/init.d/S40cron stop
/etc/rc.d/init.d/S35dhcpcd stop
/etc/rc.d/init.d/S20network stop
/etc/rc.d/init.d/S15inet stop

# wait AppleShare Daemon
wait_atalk_daemon

mount -o remount,rw %root% /
[ $? != 0 ] && error_exit

# add Ver1.40 status(lanicn-status)
if [ "${VER140UP}" != "true" ]; then
    # update landisk-config
    if [ "${FATSHARE}" = "" ]; then
        FATSHARE="off"
    fi
    if [ "${FATWINWRITE}" = "" ]; then
        FATWINWRITE="off"
    fi
    if [ "${ATALKCODE}" = "" ]; then
        ATALKCODE="cap"
    fi
    /home/LANDISK/scripts/setparam.sh "FATSHAREP1" "${FATSHARE}" /home/LANDISK/landisk-config
    [ $? != 0 ] && error_exit
    /home/LANDISK/scripts/setparam.sh "FATSHAREP2" "${FATSHARE}" /home/LANDISK/landisk-config
    [ $? != 0 ] && error_exit
    /home/LANDISK/scripts/setparam.sh "FATWINWRITEP1" "${FATWINWRITE}" /home/LANDISK/landisk-config
    [ $? != 0 ] && error_exit
    /home/LANDISK/scripts/setparam.sh "FATWINWRITEP2" "${FATWINWRITE}" /home/LANDISK/landisk-config
    [ $? != 0 ] && error_exit
    /home/LANDISK/scripts/setparam.sh "ATALKCODE" "${ATALKCODE}" /home/LANDISK/landisk-config
    [ $? != 0 ] && error_exit
    /home/LANDISK/scripts/setparam.sh "COPYDATASHARE" "" /home/LANDISK/landisk-config
    [ $? != 0 ] && error_exit
    /home/LANDISK/scripts/setparam.sh "FATSHAREP1" "${FATSHARE}" /var/lock/lanicn/lanicn-status
    [ $? != 0 ] && error_exit
    /home/LANDISK/scripts/setparam.sh "FATSHAREP2" "${FATSHARE}" /var/lock/lanicn/lanicn-status
    [ $? != 0 ] && error_exit
    /home/LANDISK/scripts/setparam.sh "FATWINWRITEP1" "${FATWINWRITE}" /var/lock/lanicn/lanicn-status
    [ $? != 0 ] && error_exit
    /home/LANDISK/scripts/setparam.sh "FATWINWRITEP2" "${FATWINWRITE}" /var/lock/lanicn/lanicn-status
    [ $? != 0 ] && error_exit
    /home/LANDISK/scripts/setparam.sh "FATUSBP1" "no" /var/lock/lanicn/lanicn-status
    [ $? != 0 ] && error_exit
    /home/LANDISK/scripts/setparam.sh "FATUSBP2" "no" /var/lock/lanicn/lanicn-status
    [ $? != 0 ] && error_exit
fi

# nsswitch.conf if Ver.1.20 before
if [ "${VER120UP}" != "true" ]; then
    SECURITY=$(grep -v '^[#\;]' /etc/samba.d/smb.conf | grep -w "security" | awk -F " = " '{print $2}')
    if [ "${SECURITY}" = "DOMAIN" ]; then
	[ -e /etc/nsswitch.conf ] && rm -f /etc/nsswitch.conf
	ln -s /etc/nsswitch.conf.local /etc/nsswitch.conf
    fi
    sync
fi

# ver.1.50 system.txt mediaRootPath backup
if [ -e /usr/local/AVeLLink/docroot/conf/AVeLLink/system.txt ]; then
    AVELSHARE=$(grep -w "mediaRootPath" /usr/local/AVeLLink/docroot/conf/AVeLLink/system.txt | awk -F "=" '{ print $2 }')
fi
if [ -e /usr/local/AVeLLink/docroot/sys/AVL/conf/system.txt ]; then
    AVELSHARE=$(grep -w "mediaRootPath" /usr/local/AVeLLink/docroot/sys/AVL/conf/system.txt | head -n 1 |awk -F "=" '{ print $2 }')
fi

# ver.1.50 delete AVeL docroot directory
if [ "${VER150UP}" != "true" ]; then
    rm -rf /usr/local/AVeLLink/docroot
fi

# copy & mode change.
if [ "${VER110UP}" != "true" ]; then
# Ver1.00 1.01
    tar xpzf /mnt/hda3/.landisk-update/update-files.tar.gz -C /
    [ $? != 0 ] && error_exit
elif  [ "${SYSVER}" = "110" ]; then
# Ver1.10
    # exclude ftp passwd,group file
    tar xpzf /mnt/hda3/.landisk-update/update-files.tar.gz -C / \
	--exclude ./etc/samba.d/smb.conf \
	--exclude ./etc/samba.d/smb.conf.ftp \
	--exclude ./etc/ftpaccess \
	--exclude ./home/LANDISK/backup-config \
	--exclude ./home/LANDISK/backuplist \
	--exclude ./home/LANDISK/crontab
    [ $? != 0 ]	&& error_exit
elif  [ "${SYSVER}" = "120" ]; then
# Ver1.20
    # exclude ftp passwd,group file
    tar xpzf /mnt/hda3/.landisk-update/update-files.tar.gz -C / \
	--exclude ./etc/samba.d/smb.conf \
	--exclude ./etc/samba.d/smb.conf.ftp \
	--exclude ./etc/ftpaccess \
	--exclude ./home/LANDISK/backup-config \
	--exclude ./home/LANDISK/backuplist \
	--exclude ./home/LANDISK/crontab \
	--exclude ./usr/local/apache/conf/httpd.conf
    [ $? != 0 ] && error_exit
elif  [ "${SYSVER}" = "121" ]; then
# Ver1.21
    # exclude ftp passwd,group file
    tar xpzf /mnt/hda3/.landisk-update/update-files.tar.gz -C / \
	--exclude ./etc/samba.d/smb.conf \
	--exclude ./etc/samba.d/smb.conf.ftp \
	--exclude ./etc/ftpaccess \
	--exclude ./home/LANDISK/backup-config \
	--exclude ./home/LANDISK/backuplist \
	--exclude ./home/LANDISK/crontab \
	--exclude ./usr/local/apache/conf/httpd.conf
    [ $? != 0 ] && error_exit
elif  [ "${SYSVER}" = "130" ]; then
# Ver1.30
    # exclude ftp passwd,group file
    tar xpzf /mnt/hda3/.landisk-update/update-files.tar.gz -C / \
	--exclude ./etc/samba.d/smb.conf \
	--exclude ./etc/samba.d/smb.conf.ftp \
	--exclude ./etc/ftpaccess \
	--exclude ./home/LANDISK/backup-config \
	--exclude ./home/LANDISK/backuplist \
	--exclude ./home/LANDISK/crontab \
	--exclude ./usr/local/apache/conf/httpd.conf
    [ $? != 0 ] && error_exit
elif  [ "${SYSVER}" = "140" -o "${SYSVER}" = "141" -o "${SYSVER}" = "142" -o "${SYSVER}" = "150" -o "${SYSVER}" = "151" -o "${SYSVER}" = "152" -o "${SYSVER}" = "153" ]; then
# Ver1.40, Ver1.41, Ver1.42, Ver1.50 Ver1.51 Ver1.52 or Ver1.53
    # exclude ftp passwd,group file
    tar xpzf /mnt/hda3/.landisk-update/update-files.tar.gz -C / \
	--exclude ./etc/samba.d/smb.conf \
	--exclude ./etc/samba.d/smb.conf.ftp \
	--exclude ./etc/ftpaccess \
	--exclude ./home/LANDISK/backup-config \
	--exclude ./home/LANDISK/backuplist \
	--exclude ./home/LANDISK/crontab \
	--exclude ./usr/local/apache/conf/httpd.conf
    [ $? != 0 ] && error_exit
fi

# extract new ftp files
if [ "${VER110UP}" != "true" ]; then
    tar xpzf /root/.initfile/ftp.tar.gz -C /mnt/hda3/share
    [ $? != 0 ] && error_exit
    chmod -R 775 /mnt/hda3/share/ftp/ftp
else
    # exclude ftp passwd,group file
    tar xpzf /root/.initfile/ftp.tar.gz -C /mnt/hda3/share \
	--exclude ./ftp/etc/passwd \
	--exclude ./ftp/etc/group
    [ $? != 0 ] && error_exit
fi

# chown,chmod lilo.conf
chown root:root /etc/lilo.conf
chmod 644 /etc/lilo.conf

# lilo
/sbin/lilo -v -r /
[ $? != 0 ] && error_exit


# Version UP.


if [ "${VER110UP}" != "true" ]; then
    # update landisk-config
    /home/LANDISK/scripts/setparam.sh "ANONYMODE" "on" /home/LANDISK/landisk-config
    [ $? != 0 ] && error_exit
    /home/LANDISK/scripts/setparam.sh "FTPUSRMODE" "off" /home/LANDISK/landisk-config
    [ $? != 0 ] && error_exit
    /home/LANDISK/scripts/setparam.sh "FTPUSR" "" /home/LANDISK/landisk-config
    [ $? != 0 ] && error_exit


    # update smb.conf. once get current config then apply current config to
    # new smb.conf

    TMPFILE="/tmp/landisk-update.sh.tmp"

    /home/LANDISK/scripts/getsmbparam.sh "global" "netbios name" ${TMPFILE}
    [ $? = 0 ] && NETBIOS_NAME=$(cat ${TMPFILE})
    /home/LANDISK/scripts/getsmbparam.sh "global" "workgroup" ${TMPFILE}
    [ $? = 0 ] && WORKGROUP=$(cat ${TMPFILE})
    /home/LANDISK/scripts/getsmbparam.sh "global" "server string" ${TMPFILE}
    [ $? = 0 ] && SERVER_STRING=$(cat ${TMPFILE})
    /home/LANDISK/scripts/getsmbparam.sh "global" "security" ${TMPFILE}
    [ $? = 0 ] && SECURITY=$(cat ${TMPFILE})
    /home/LANDISK/scripts/getsmbparam.sh "global" "wins server" ${TMPFILE}
    [ $? = 0 ] && WINS_SERVER=$(cat ${TMPFILE})
    /home/LANDISK/scripts/getsmbparam.sh "global" "password server" ${TMPFILE}
    [ $? = 0 ] && PASSWORD_SERVER=$(cat ${TMPFILE})

    # get new smb.conf from initial tar archive
    tar xzpf /root/.initfile/init-config.tar.gz -C / ./etc/samba.d/smb.conf
    /home/LANDISK/scripts/setsmbglobal.sh "${WORKGROUP}" "${SERVER_STRING}" "${SECURITY}" "${WINS_SERVER}" "${PASSWORD_SERVER}"

    rm ${TMPFILE}

    mount -o remount,rw %root% /
    [ $? != 0 ] && error_exit

    # update crontab(apply current cron config)

    # Check NTP cron sync
    [ -f /etc/sysconfig/ntp ] && NTPSYNC=$(grep -v '^[#\;]' /etc/sysconfig/ntp | grep -w "NTPSYNC" | awk -F "=" '{print $2}')
    [ -f /etc/sysconfig/ntp ] && CRONSYNC=$(grep -v '^[#\;]' /etc/sysconfig/ntp | grep -w "CRONSYNC" | awk -F "=" '{print $2}')

    # if NTP sync by cron then apply crontab
    if [ "${NTPSYNC}" = "on" ] && [ "${CRONSYNC}" = "on" ]; then
        grep "ntpsync.sh" /home/LANDISK/scripts/crontab-ntp >> /home/LANDISK/crontab
    fi
fi

# Ver1.20 add parameter
if [ "${VER120UP}" != "true" ]; then
    /home/LANDISK/scripts/setparam.sh "AVELLINK" "off" /home/LANDISK/landisk-config
    [ $? != 0 ] && error_exit
    /home/LANDISK/scripts/setparam.sh "AVELSHARE" "" /home/LANDISK/landisk-config
    [ $? != 0 ] && error_exit
fi

/home/LANDISK/scripts/setparam.sh "SYSTEMVERSION" "${UPDATEVERSION}" /home/LANDISK/landisk-config
[ $? != 0 ] && error_exit

# all version.
if ! grep "   printer admin = admin, nobody" /etc/samba.d/smb.conf
    then
    cat /etc/samba.d/smb.conf | sed 's/   printer admin = admin/   printer admin = admin, nobody/' > /tmp/smb.conf
    mv /tmp/smb.conf /etc/samba.d/smb.conf
fi

# Ver1.20 Change httpd.conf if AVeL on.
if [ "${AVELLINK}" = "on" ]; then
    rm -f /usr/local/apache/conf/httpd.conf
    ln -s /usr/local/apache/conf/httpd_AVeLLink.conf /usr/local/apache/conf/httpd.conf
fi

# Ver1.50 restore mediaRootPath to system.txt
/home/LANDISK/scripts/setparam.sh "mediaRootPath" "${AVELSHARE}" /usr/local/AVeLLink/docroot/sys/AVL/conf/system.txt

sync
mount -o remount,ro %root% /

rm -rf /mnt/hda3/.landisk-update/update.tgz
rm -rf /mnt/hda3/.landisk-update/update-files.tar.gz

# Wait
sync
mount -o remount,ro /dev/hda3 /mnt/hda3
# sleep 10

/home/LANDISK/scripts/powerctrl.sh reboot
exit 0

